// Grid system
@function emify($target, $context: $font-size) {
  @if $target == 0 { @return 0 }
  @return $target / $context + 0em;
}

@mixin scale-font($size) {
  font-size: $size;
  line-height: $size*1.5;
}

// set grid rhythm
$grid: 22px; // set to your desired line-height and base grid unit
$font-size: $grid / 1.375; // set the number to your desired line-height ratio

// automagics
$line-height: emify($grid);
$of-default-font-size: percentage($font-size / 16px);

// Responsive Presets
$breakpoint-dektop: $grid * 44;
$breakpoint-tablet: $grid * 30;

$width-content-desktop: $grid * 22;
$width-content-tablet: $grid * 16;

// Responsive Breakpoints
$mobile-breakpoint-small: $grid * 30; // 660 px
$mobile-breakpoint-medium: $grid * 40; // 880 px
$mobile-breakpoint-large: $grid * 50; // 1100 px

// Dimensions
$width-touchpoint-nav: $grid * 8;

// LG G5 or Galaxy Note 5
// $width-phone-screen-larger: 480px;
// $height-phone-screen-larger: 853px;

// iPhone X
// $width-phone-screen-small: 375px;
// $height-phone-screen-small: 812px;

// Large e.g. iPhone 6+
$width-phone-screen-large: 414px;
// $height-phone-screen-small: 736px;

// Medium e.g. iPhone 6
$width-phone-screen-small: 375px;
$height-phone-screen-small: 667px;

// Small e.g. Kevin's busted ass old phone
// $width-phone-screen-small: 320px;
// $height-phone-screen-small: 568px;

$width-action-bar: $width-phone-screen-small - 2px;
$height-action-bar: 55px;

$width-status-bar: $width-phone-screen-small - 2px;
$height-status-bar: 20px;

$width-nav-bar: $width-phone-screen-small - 2px;
$height-nav-bar: $grid * 2.5;

$width-nav-bar-drawer: $width-phone-screen-small - 2px;
$height-nav-bar-drawer: 50px;

$width-subnav-bar-text: $width-phone-screen-small - 2px;
$height-subnav-bar-text: 30px;

$width-page-notes: 65%;

$height-txn-status-bar: $grid / 3;

$color-error: red;
$color-error-text: white;

// Colors
// Primary Brand Colors
$color-brand-orange: #F9A538;
$color-brand-pink: #FF4F94;

$color-background-highlight: #aaa;

// Dark Mode Colors
$color-dark-mode-bg: #302442;
$color-dark-mode-primary: #29ABE2;
$color-dark-mode-highlight: #32C3B2;
$color-dark-mode-pending: #F5A623;
$color-dark-mode-error: #E90404;
$color-dark-mode-normal: #323134;
$color-dark-mode-off-gray: #CBC4DA;

// Secondary Brand Colors
$color-brand-magenta: #D742FF;
$color-brand-green: #4CBF2C;
$color-brand-green-light: #9bd555;
$color-brand-blue: #4b77f3;
$color-brand-blue-light: #4995ff;
$color-brand-dark: #302442;

// Texts & Grays
$color-text: #546875;
$color-quiet: lighten($color-text, 25%);
$color-quieter: lighten($color-text, 35%);
$color-quietest: lighten($color-text, 40%);
$color-gray: #111;
$color-black: darken($color-brand-dark, 12%);

// Currency & Other Brand Colors
$color-ethereum-primary: #5e6fa5;
$color-ethereum-secondary: lighten($color-ethereum-primary, 10%);

$color-xjp-primary: #d3430d;
$color-xjp-secondary: lighten($color-xjp-primary, 10%);

$color-bitcoin-primary: #f29500;
$color-bitcoin-secondary: lighten($color-bitcoin-primary, 10%);

$color-bitcoin-cash-primary: #478559;
$color-bitcoin-cash-secondary: lighten($color-bitcoin-cash-primary, 10%);

$color-omisego-primary: #3a8cdd;
$color-omisego-secondary: lighten($color-omisego-primary, 10%);

$color-glidera-primary: #4f6e89;
$color-glidera-secondary: #394551;

// Other Colors
$color-quiet-white: rgba(white, .7);
$color-quieter-white: rgba(white, .5);
$color-quietest-white: rgba(white, .15);

$color-whisper: lighten($color-text, 50%);
$color-whisperer: #ececec;
$color-red: #f46b41;
$color-ghost: #f5f7fa;
$color-white: #f9fbfe;
$color-overlay-dark: rgba(0,0,0,.8);
$color-overlay: rgba(0,0,0,.55);
$color-overlay-quiet: rgba(0,0,0,.15);
$color-overlay-quieter: rgba(0,0,0,.07);
$color-overlay-white: rgba(white, .25);
$color-overlay-whiter: rgba(white, .5);

$color-dark-mode-bg: #302442;
$color-light-mode-bg: $color-white;

$color-active: #2196f3;

$color-dev: rgba($color-red, .1);

// Borders
$border: 1px solid $color-whisperer;
$border-trans: 1px solid rgba(white, .25);
$border-trans-dark: 1px solid rgba(black, .1);
$border-dark: 1px solid $color-glidera-secondary;
$border-phone: 1px solid $color-whisper;

// Typefaces
$font-serif: serif;
$font-sans: sans-serif;
$font-sans-bold: sans-serif;

// Font sizes
$font-size-h1: $font-size * 2.5; // 40px
$font-size-h2: $font-size * 1.75; // 32px
$font-size-h3: $font-size * 1.5; // 28px
$font-size-h4: $font-size * 1.25; // 24px
$font-size-h5: $font-size * 1.25; // 20px
$font-size-h6: $font-size * 1.13; // 18px
$font-size-small: $font-size * .875; // 14px
$font-size-smaller: $font-size * .75; // 12px
$size-icon: $font-size * 1.5;
$size-icon-small: $font-size * 1.125;
$font-size-bigger: $font-size * 2.25; // 36px

// Other
$opacity-hover: .85;
$img-path: "~/assets/img/";

@mixin font-multiple($f) {
  font-size: $grid*$f*0.65;
  line-height: $grid*$f;
  height: $grid*$f;
}

// Mixins
@mixin text-shadow {
  text-shadow: 0px 1px 6px rgba(0,0,0, .9);
}

@mixin text-shadow-light {
  text-shadow: 0px 1px 2px rgba(0,0,0, .25);
}

@mixin box-shadow-weak {
  box-shadow: 0 0 2px rgba(0,0,0,.06), 0 1px 3px rgba(0,0,0,.08);
}

@mixin box-shadow-low {
  box-shadow: 0 0px 2px rgba(0,0,0,0.06), 0 1px 3px rgba(0,0,0,0.08);
}

@mixin box-shadow {
  box-shadow: 0 1px 3px rgba(0,0,0,0.08), 0 0px 4px rgba(0,0,0,0.12);
}

@mixin box-shadow-high {
  box-shadow: 0 3px 9px rgba(0,0,0,0.12), 0 2px 6px rgba(0,0,0,0.24);
}

@mixin box-shadow-big {
  box-shadow: 0 15px 35px rgba(50, 50, 90, .1), 0 5px 15px rgba(0, 0, 0, .07);
}

@mixin box-shadow-big-light {
  box-shadow: 0 15px 35px rgba(255, 255, 255, .1), 0 5px 15px rgba(255, 255, 255, .07);
}

@mixin box-shadow-little {
  box-shadow: rgba(50, 50, 93, 0.11) 0px 4px 6px 0px, rgba(0, 0, 0, 0.08) 0px 1px 3px 0px;
}

@mixin box-shadow-inner {
  -webkit-box-shadow: inset 0px 1px 4px 0px rgba(0,0,0,.07);
}

@mixin box-shadow-inner-big {
  box-shadow: inset 0 15px 35px rgba(50, 50, 90, .1), inset 0 5px 15px rgba(0, 0, 0, .07);
}

@mixin box-shadow-kill {
  box-shadow: 0 1px 3px rgba(0,0,0,0.0), 0 1px 2px rgba(0,0,0,0.0);
}

@mixin box-sizing($box-sizing-value: border-box) {
  -moz-box-sizing: $box-sizing-value;
  -webkit-box-sizing: $box-sizing-value;
  box-sizing: $box-sizing-value;
}

@mixin corners($tr: 4px, $tl: 4px, $bl: 4px, $br: 4px) { /* this could probably be less verbose at some point */
  -webkit-border-top-left-radius: $tr;
  -moz-border-radius-topleft: $tr;
  border-top-left-radius: $tr;
  -webkit-border-top-right-radius: $tl;
  -moz-border-radius-topright: $tl;
  border-top-right-radius: $tl;
  -webkit-border-bottom-left-radius: $bl;
  -moz-border-radius-bottomleft: $bl;
  border-bottom-left-radius: $bl;
  -webkit-border-bottom-right-radius: $br;
  -moz-border-radius-bottomright: $br;
  border-bottom-right-radius: $br;
}

@mixin card {
  // @include box-shadow-low;
  @include corners;
  margin: $grid / 2 $grid / 1.5;
}

@mixin flex_column {
  display: flex;
  flex-direction: column;
  align-items: center;
}

@mixin flex_row {
  display: flex;
  flex-direction: row;
  align-items: center;
}

@mixin row {
  @include flex_row;
  padding: $grid/2 $grid/1.5;
  min-height: 54px;
  width: 100%;
}

@mixin gradient($stop1, $stop2) {
  background: -moz-linear-gradient(top,  $stop1, $stop2); /* FF3.6+ */
  background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,rgba(255,255,255,0.01)), color-stop(16%,rgba(255,255,255,1))); /* Chrome,Safari4+ */
  background: -webkit-linear-gradient(top,  $stop1,$stop2); /* Chrome10+,Safari5.1+ */
  background: -o-linear-gradient(top,  $stop1,$stop2); /* Opera 11.10+ */
  background: -ms-linear-gradient(top,  $stop1,$stop2); /* IE10+ */
  background: linear-gradient(to bottom,  $stop1,$stop2); /* W3C */
}

@mixin gradient-horizontal($stop1, $stop2) {
  background: -moz-linear-gradient(left,  $stop1, $stop2); /* FF3.6+ */
  background: -webkit-gradient(linear, left center, right center, color-stop(0%,rgba(255,255,255,0.01)), color-stop(16%,rgba(255,255,255,1))); /* Chrome,Safari4+ */
  background: -webkit-linear-gradient(left,  $stop1,$stop2); /* Chrome10+,Safari5.1+ */
  background: -o-linear-gradient(left,  $stop1,$stop2); /* Opera 11.10+ */
  background: -ms-linear-gradient(left,  $stop1,$stop2); /* IE10+ */
  background: linear-gradient(to right,  $stop1,$stop2); /* W3C */
}

@mixin gradient-diagonal-topleft($stop1, $stop2) {
  background: -moz-linear-gradient(-45deg, $stop1, $stop2); /* FF3.6+ */
  background: -webkit-linear-gradient(-45deg,  $stop1,$stop2); /* Chrome10+,Safari5.1+ */
  background: -o-linear-gradient(-45deg,  $stop1,$stop2); /* Opera 11.10+ */
  background: -ms-linear-gradient(-45deg,  $stop1,$stop2); /* IE10+ */
  background: linear-gradient(135deg,  $stop1,$stop2); /* W3C */
  filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='$stop1', endColorstr='$stop2',GradientType=1 ); /* IE6-9 fallback on horizontal gradient */

}

@mixin gradient-diagonal-topright($stop1, $stop2) {
  background: -moz-linear-gradient(45deg, $stop1, $stop2); /* FF3.6+ */
  background: -webkit-linear-gradient(45deg,  $stop1,$stop2); /* Chrome10+,Safari5.1+ */
  background: -o-linear-gradient(45deg,  $stop1,$stop2); /* Opera 11.10+ */
  background: -ms-linear-gradient(45deg,  $stop1,$stop2); /* IE10+ */
  background: linear-gradient(45deg,  $stop1,$stop2); /* W3C */
  filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='$stop1', endColorstr='$stop2',GradientType=1 ); /* IE6-9 fallback on horizontal gradient */

}

@mixin gradient-brand {
  @include gradient-diagonal-topright($color-brand-pink, $color-brand-orange);
}

@mixin gradient-brand-animated {
  background: -moz-linear-gradient(-45deg, $color-brand-orange, $color-brand-orange, $color-brand-pink, $color-brand-magenta, $color-brand-blue, $color-brand-green, $color-brand-green); /* FF3.6+ */
  background: -webkit-linear-gradient(-45deg, $color-brand-orange, $color-brand-orange, $color-brand-pink, $color-brand-magenta, $color-brand-blue, $color-brand-green, $color-brand-green); /* Chrome10+,Safari5.1+ */
  background: -o-linear-gradient(-45deg, $color-brand-orange, $color-brand-orange, $color-brand-pink, $color-brand-magenta, $color-brand-blue, $color-brand-green, $color-brand-green); /* Opera 11.10+ */
  background: -ms-linear-gradient(-45deg, $color-brand-orange, $color-brand-orange, $color-brand-pink, $color-brand-magenta, $color-brand-blue, $color-brand-green, $color-brand-green); /* IE10+ */
  background: linear-gradient(135deg, $color-brand-orange, $color-brand-orange, $color-brand-pink, $color-brand-magenta, $color-brand-blue, $color-brand-green, $color-brand-green); /* W3C */
  background-size: 600% 600%;
  -webkit-animation: Gradient 40s ease infinite;
  -moz-animation: Gradient 40s ease infinite;
  animation: Gradient 40s ease infinite;
}

@-webkit-keyframes Gradient {
	0% {
		background-position: 0% 50%
	}
	50% {
		background-position: 100% 50%
	}
	100% {
		background-position: 0% 50%
	}
}

@-moz-keyframes Gradient {
	0% {
		background-position: 0% 50%
	}
	50% {
		background-position: 100% 50%
	}
	100% {
		background-position: 0% 50%
	}
}

@keyframes Gradient {
	0% {
		background-position: 0% 50%
	}
	50% {
		background-position: 100% 50%
	}
	100% {
		background-position: 0% 50%
	}
}

@mixin gradient-brand-pantone {
  @include gradient-horizontal(#f04e98, #ff9e1a);
}

@mixin gradient-brand-secondary {
  @include gradient-horizontal($color-brand-pink, $color-brand-magenta);
}

@mixin gradient-bitcoin {
  @include gradient-horizontal($color-bitcoin-primary, $color-bitcoin-secondary);
}

@mixin gradient-bitcoin-cash {
  @include gradient-horizontal($color-bitcoin-cash-primary, $color-bitcoin-cash-secondary);
}

@mixin gradient-ethereum {
  @include gradient-horizontal($color-ethereum-primary, $color-ethereum-secondary);
}

@mixin gradient-omisego {
  @include gradient-horizontal($color-omisego-primary, $color-omisego-secondary);
}

@mixin gradient-xjp {
  @include gradient-horizontal($color-xjp-primary, $color-xjp-secondary);
}

@mixin gradient-button {
  @include gradient(#c653ff, #8600c8);
}

@mixin gradient-black-fade {
  @include gradient(rgba(0,0,0,.0), rgba(0,0,0,1));
}

@mixin gradient-text-brand {
  @include gradient-brand;
  background-position: 50% 50%;
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
}

@mixin gradient-text-brand-secondary {
  @include gradient-brand-secondary;
  background-position: 50% 50%;
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
}

$time: 300ms;

$transition: $time cubic-bezier(0.330, 0.465, 0.180, 1)  all;
$transition-motion: $time ease all;

@mixin no_spring {
  transition: all $time cubic-bezier(0.330, 0.465, 0.180, 1); /* custom */
  transition-timing-function: cubic-bezier(0.330, 0.465, 0.180, 1); /* custom */
}

@mixin rounded-corners($radius: $grid*0.2) {
  border-radius: $radius;
}

@mixin rounded-left-corners($radius: $grid*0.2) {
  border-radius: $radius 0 0 $radius;
}

@mixin rounded-right-corners($radius: $grid*0.2) {
  border-radius: 0 $radius $radius 0;
}

@mixin rounded-bottom-left-corner($radius: $grid*0.2) {
  border-radius: 0 0 0 $radius;
}

@mixin rounded-bottom-right-corner($radius: $grid*0.2) {
  border-radius: 0 0 $radius 0;
}

@mixin button-row {
  display: flex;
  flex-direction: row;

  & > .button-container {
    padding: 0;
    margin: 0;
    flex-grow: 1;

    & > .button {
      border-radius: 0;
    }
  }
}

@mixin button-container {
  margin: $grid*0.5 0;
  padding: 0 $grid;
  border: none;
  display: flex;

  /*& > button {
    background-color: transparent;
  }*/

  &.button-container__row {
    margin: 0;
    padding: 0;

    border-right: $border;
    &:last-child {
      border-right: none;
    }

    &:first-child > button {
      @include rounded-bottom-left-corner($grid*0.25);
    }
    &:last-child > button {
      @include rounded-bottom-right-corner($grid*0.25);

    }
  }
}

@mixin admin-button {
  border: 0;
  box-shadow: 0 2px 2px 0 rgba(0,0,0,0.14), 0 3px 1px -2px rgba(0,0,0,0.12), 0 1px 5px 0 rgba(0,0,0,0.2);

  font-family: $font-sans;
  font-size: $grid*0.75;

  @include rounded-corners($grid*0.25);

  &.button__row {
    @include rounded-corners(0);
    border: none;
  }

  &.button__normal , &.button__secondary{
    padding: $grid*0.5 $grid;

    @include box-shadow-low;

    &[disabled],&:disabled {
      background-color: $color-gray;
    }
  }

  &.button__normal {
    background-color: $color-brand-blue-light;
    color: $color-quiet-white;
  }

  &.button__small {
    background-color: $color-brand-blue-light;
    color: $color-quiet-white;
  }

  &.button__borderless {
    border: none;
  }

  &.button__small-transparent {

  }
}

@mixin button {
  @include box-sizing;
  @include corners;
  height: $grid * 1.5;
  position: relative;
  display: inline-flex;
  justify-content: center;
  align-items: center;
  flex-direction: row;
  flex-wrap: none;
  flex: 0 0 content;
  padding: 0 $grid * .75;

  margin-bottom: $grid;
  // Background & borders

  background-color: $color-brand-magenta;
  color: white;
  font-size: $font-size;
  line-height: $line-height;
  font-family: $font-sans-bold;
  font-weight: normal;
  text-align: center;
  text-decoration: none;
  transition: $transition;
  cursor: pointer;
}

@mixin pwb-button {
  @include rounded-corners(2px);
  font: $grid*0.75/1 $font-sans;
  border: 0;
  background-color: $color-dark-mode-primary;
  color: $color-white;
  padding: 16px 0;

  &[disabled] {
    opacity: 0.3;
    cursor: default;
  }
}

// Placeholders
%material-box {
  box-shadow: 0 2px 2px 0 rgba(0,0,0,0.14), 0 3px 1px -2px rgba(0,0,0,0.12), 0 1px 5px 0 rgba(0,0,0,0.2);
}

%material-button {
  @extend %material-box;
  border: 0;
  border-radius: 2px;
  padding: 10px 15px;
}

%form-input {
  border-radius: 2px;
  font-size: $font-size;
  line-height: $grid;
  width: 100%;
  background: $color-white;

  padding: ($grid * 0.75) $grid;

  font-family: $font-sans;
  color: $color-dark-mode-normal
}

@mixin absolute-full {
  position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
}

@mixin fixed-full {
  position: fixed;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
}


@mixin row-padding-between($space: $grid) {
  & > .ui-column , & > .ui-row , & > .ui-cell {
    margin-left: $space;
    margin-right: $space;

    &:first-child {
      margin-left: 0;
    }
    &:last-child {
      margin-right: 0;
    }
  }
}

@mixin row-padding-between-reverse($space: $grid) {
  & > .ui-column , & > .ui-row , & > .ui-cell {
    margin-left: $space;
    margin-right: $space;

    &:first-child {
      margin-right: 0;
    }
    &:last-child {
      margin-left: 0;
    }
  }
}


@mixin column-padding-between($space: $grid) {
  & > .ui-column , & > .ui-row , & > .ui-cell {
    margin-top: $space;
    margin-bottom: $space;

    &:first-child {
      margin-top: 0;
    }
    &:last-child {
      margin-bottom: 0;
    }
  }
}


@mixin column-padding-between-reverse($space: $grid) {
  & > .ui-column , & > .ui-row , & > .ui-cell {
    margin-top: $space;
    margin-bottom: $space;

    &:first-child {
      margin-bottom: 0;
    }
    &:last-child {
      margin-top: 0;
    }
  }
}

@mixin padding-between($space: $grid) {
  &.ui-row {
    @include row-padding-between($space);
  }

  &.ui-column {
    @include column-padding-between($space);
  }
}

@mixin mobile-only {
	@media (max-width : 600px) {
		@content;
	}
}

@mixin not-mobile {
  @media (min-width: 601px) {
    @content;
  }
}
